/*
* Template-File src/main/takatuka/templates/EntityAbstractSearch.vm
*/
package de.ivu.elect.business.personenpruefung.boundary;

import java.util.List;

import javax.inject.Inject;

import de.ivu.elect.business.personenpruefung.entity.ExternerAbgleich;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.jee.presentation.search.WildcardConverter;

public abstract class AbstractExternerAbgleichSearch {

  @Inject
  protected transient ExternerAbgleichExtendedDAO dao;

  public AbstractExternerAbgleichSearch() {
    super();
  }

  public List<ExternerAbgleich> getSearchResult(ExternerAbgleichSearchParameters searchParameters, EagerLoadingCollector<ExternerAbgleich> eagerLoadingCollector) {
    return eagerLoadingCollector.eagerLoad(querySearchResult(searchParameters));
  }

  protected abstract List<ExternerAbgleich> querySearchResult(ExternerAbgleichSearchParameters searchParameters);

  protected String convertSearchPattern(String patternInput) {
    return new WildcardConverter().addAndConvertToJpqlLikeExpression(patternInput);
  }
}
